# https://github.com/aardappel/treesheets/releases
%global commit  b728fe6dd034fe80cc46b8ebaaa20b30f018c9d9

%global rdns    com.strlen.TreeSheets

Name:           treesheets
# No proper versioning. Upstream uses the global GitHub Actions run ID to tag releases
Version:        0.6420493915
Release:        2%{?dist}
Summary:        Free-form data organizer / hierarchical spreadsheet
License:        Zlib
URL:            http://strlen.com/%{name}

Source0:        https://github.com/aardappel/%{name}/archive/%{commit}/%{name}-%{commit}.tar.gz

# Keep compatibility with wxWidgets 3.2. See discussion upstream:
# <https://github.com/aardappel/treesheets/pull/522#issuecomment-1737975153>
Patch0:         %{name}-0001-wxWidgets-3.2.patch

BuildRequires:  gcc gcc-c++
BuildRequires:  cmake
# wxGTK-devel is the 3.2.x (or later) package
# wxGTK3-devel is pinned to 3.0.x
BuildRequires:  wxGTK-devel

BuildRequires:  desktop-file-utils
BuildRequires:  sed

%description
TreeSheets is a "hierarchical spreadsheet" that is a great replacement
for spreadsheets, mind mappers, outliners, PIMs, text editors
and small databases.

Suitable for any kind of data organization, such as todo lists, calendars,
project management, brainstorming, organizing ideas, planning,
requirements gathering, presentation of information, etc.


%prep
%autosetup -n %{name}-%{commit} -p1

chmod 0644 ZLIB_LICENSE.txt

# Fix line endings
# <https://fedoraproject.org/wiki/Common_Rpmlint_issues#wrong-file-end-of-line-encoding>
sed -i -e 's/\r$//' ZLIB_LICENSE.txt TS/docs/*.txt

# Set version in About dialog
sed -i -e '0,/info.SetVersion(wxT(PACKAGE_VERSION));/s//info.SetVersion(L"%{version}-%{release}");/' src/document.h


%build
%cmake -DCMAKE_BUILD_TYPE:STRING=Release

%cmake_build


%install
%cmake_install

%find_lang ts


%check
desktop-file-validate %{buildroot}%{_datadir}/applications/%{rdns}.desktop


%files -f ts.lang
%license ZLIB_LICENSE.txt
%doc %{_pkgdocdir}
%{_bindir}/%{name}
%{_datadir}/%{name}/
%{_datadir}/applications/%{rdns}.desktop
%{_datadir}/icons/hicolor/scalable/apps/%{rdns}.svg
%{_datadir}/mime/packages/%{rdns}.xml


%changelog
* Thu Oct 05 2023 Justin Koh <j@ustink.org> - 0.6420493915-2
- Fix build due to renamed files (#523, #524)

* Thu Oct 05 2023 Justin Koh <j@ustink.org> - 0.6420493915-1
- New upstream version

* Tue Sep 19 2023 Justin Koh <j@ustink.org> - 0.6229949527-1
- New upstream version

* Thu Sep 07 2023 Justin Koh <j@ustink.org> - 0.6111899184-1
- New upstream version

* Wed Aug 02 2023 Justin Koh <j@ustink.org> - 0.5742171156-1
- New upstream version

* Thu Jul 20 2023 Justin Koh <j@ustink.org> - 0.5603312701-1
- New upstream version

* Thu Jul 13 2023 Justin Koh <j@ustink.org> - 0.5536594709-1
- New upstream version

* Wed Jul 12 2023 Justin Koh <j@ustink.org> - 0.5534910414-1
- New upstream version

* Wed Jul 12 2023 Justin Koh <j@ustink.org> - 0.5522901448-1
- Update to 5522901448, drop unused patch

* Wed Jul 05 2023 Justin Koh <j@ustink.org> - 0.5459420450-1
- Update to 5459420450

* Sat Jul 01 2023 Justin Koh <j@ustink.org> - 0.5425923725-1
- Update to 5425923725

* Sat Jun 24 2023 Justin Koh <j@ustink.org> - 0.5338287464-1
- Update to 5338287464

* Wed Jun 14 2023 Justin Koh <j@ustink.org> - 0.5260847649-1
- Update to 5260847649 - Add drag and drop copy out of TS (#440)

* Sun Jun 04 2023 Justin Koh <j@ustink.org> - 0.5166371500-1
- Update to 5166371500

* Thu Jun 01 2023 Justin Koh <j@ustink.org> - 0.5127180840-1
- Update to 5127180840

* Tue May 23 2023 Justin Koh <j@ustink.org> - 0.5050257062-2
- Add patch to skip clang-tidy

* Tue May 23 2023 Justin Koh <j@ustink.org> - 0.5050257062-1
- Update to 5050257062

* Wed May 17 2023 Justin Koh <j@ustink.org> - 0.4996613014-1
- Update to 4996613014 - Adds copying as HTML

* Mon May 15 2023 Justin Koh <j@ustink.org> - 0.4969521204-1
- Update to 4969521204

* Wed May 03 2023 Justin Koh <j@ustink.org> - 0.4855746547-1
- Update to 4855746547

* Mon Apr 17 2023 Justin Koh <j@ustink.org> - 0.4715791278-1
- Update to 4715791278

* Wed Mar 08 2023 Justin Koh <j@ustink.org> - 0.4361168170-1
- Update to 4361168170
- Fixes #349 - Crash when extending selection with mouse after deleting a child grid

* Mon Mar 06 2023 Justin Koh <j@ustink.org> - 0.4338874921-1
- Update to 4338874921 - Search, edit improvements (#346, #347, #348)

* Sat Mar 04 2023 Justin Koh <j@ustink.org> - 0.4325606588-1
- Update to 4325606588 - Fix segfault in previous build (#345)

* Fri Mar 03 2023 Justin Koh <j@ustink.org> - 0.4317652714-1
- Update to 4317652714 - Remember last selection on load; add save images to disk

* Thu Feb 23 2023 Justin Koh <j@ustink.org> - 0.4245087767-1
- Update to 4245087767 - Add case-sensitive search (#340)

* Wed Feb 22 2023 Justin Koh <j@ustink.org> - 0.4237062766-1
- Update to 4237062766 - Add basis for generic image format support (#338)

* Fri Feb 03 2023 Justin Koh <j@ustink.org> - 0.4061386689-1
- Update to 4061386689 - replace simple image checksum with 64-bit hash (fixes #335)

* Sat Jan 28 2023 Justin Koh <j@ustink.org> - 0.3989467383-1
- Update to 3989467383 - Consider Wayland scaling (#333)

* Mon Jan 23 2023 Justin Koh <j@ustink.org> - 0.3983562083-1
- Update to 3983562083 - Add mime info (#334)
- *.cts files are now automatically associated with TreeSheets.

* Sat Jan 21 2023 Justin Koh <j@ustink.org> - 0.3971349099-1
- Update to 3971349099

* Tue Jan 03 2023 Justin Koh <j@ustink.org> - 0.3824776578-1
- Update to 3824776578

* Thu Dec 29 2022 Justin Koh <j@ustink.org> - 0.3748693451-1
- Update to 3748693451

* Tue Dec 13 2022 Justin Koh <j@ustink.org> - 0.3724685119-1
- Update to 3724685119
- Set package version in TreeSheets

* Mon Dec 12 2022 Justin Koh <j@ustink.org> - 0.3680832204-1
- Update to 3680832204

* Mon Dec 12 2022 Justin Koh <j@ustink.org> - 0.3673706181-1
- Update to 3673706181

* Sun Dec 11 2022 Justin Koh <j@ustink.org> - 0.3665322033-2
- Fix packaging issues

* Sat Dec 10 2022 Justin Koh <j@ustink.org> - 0.3665322033-1
- Initial build
